function printLog(message) {
    console.log(message);
    $("#results").html(message + "<br />-------<br />" + $("#results").html());
}

var app = {
    // Application Constructor
    initialize: function() {
        document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);

        $("#echo").click(function(){
            cordova.plugins.akaIntegration.echo("It's working!", function(response){
                printLog(response);
            }, function(error){
                printLog(error);
            });
        });

        $("#printConfig").click(function(){
            cordova.plugins.akaIntegration.printConfig(function(response){
                printLog(response);
            }, function(error){
                printLog(error);
            });
        });

        $("#printCache").click(function(){
            cordova.plugins.akaIntegration.printCache(function(response){
                printLog(response);
            }, function(error){
                printLog(error);
            });
        });

        $("#registerSegment").click(function(){
            var segments = $("#segmentsField").val();
            printLog("Register segments: " + segments)

            cordova.plugins.akaIntegration.registerSegment(segments, function(response){
                printLog(response);
            }, function(error){
                printLog(error);
            });
        });

         $("#sampleImgPreposABC").click(function(){
            var url = "https://www.akamai.com/us/en/multimedia/images/callout/akamai-about-who-we-are.jpg";
            $("#urlField").val(url);
        });

        $("#sampleImg1").click(function(){
            var url = "https://placekitten.com/200/287";
            $("#urlField").val(url);
        });

        $("#sampleImg2").click(function(){
            var url = "https://placekitten.com/96/139";
            $("#urlField").val(url);
        });

        $("#sampleImgPreposDEF").click(function(){
            var url = "https://placekitten.com/96/140";
            $("#urlField").val(url);
        });

        $("#loadImage").click(function(){
            var url = $("#urlField").val();
            printLog("Loading image: " + url)
            $("#loadedImgUrl").html(url)
            $("#loadedImage").attr("src", url);
            printLog("Loaded image: " + url)
        });

        $("#makeRequest").click(function(){
            var url = $("#urlField").val();
            printLog("Making URL request: " + url)
            $.ajax({
                url: url,
                success: handleResult
            }); // use promises

            function handleResult(result){
                printLog("Loaded URL request: " + url)
            }
        });

        $("#startAction").click(function(){
            var name = $("#actionName").val();
            printLog("Starting action: " + name)
            cordova.plugins.akaIntegration.startAction(name, function(response){
                printLog(response);
            }, function(error){
                printLog(error);
            });
        });

        $("#stopAction").click(function(){
            printLog("Stopping last action")
            cordova.plugins.akaIntegration.stopAction(function(response){
                printLog(response);
            }, function(error){
                printLog(error);
            });
        });

         $("#getToken").click(function(){
            window.FirebasePlugin.getToken(function(token) {
                // save this server-side and use it to push notifications to this device
                printLog("getToken: " + token);
            }, function(error) {
                printLog("getToken error: " + error);
            });
        });
    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
        printLog('Received Event: deviceready');

        //for iOS Notifications
        window.FirebasePlugin.grantPermission(function(response){
            printLog("Grant permission response: " + response);
        }, function(error){
            printLog("Grant permission error: " + error);
        });

        window.FirebasePlugin.onMessageReceived(function(message) {
            var notificationJson = JSON.stringify(message);
            printLog("Notification received: " + notificationJson);
            
            //pass it to Akamai SDK
            cordova.plugins.akaIntegration.handleNotification(message, function(response){
                printLog("Handled by Akamai SDK: " + response + "; notification: " + notificationJson);
                if (response === false) {
                    //handle notification
                    printLog("Need to handle this notification: " + notificationJson);
                }
            }, function(error){
                printLog("handleNotification error: " + error);
            });
        }, function(error) {
            printLog("onMessageReceived error: " + error);
        });
    }
};

app.initialize();
